'''
WIP functions for the rigify custom constraints utility, needs cleaning up, might be buggy, etc... 
-Velocirection
'''

import bpy
import os
from pprint import pprint

DELIMITER = "$:"
CUSTOM_CONSTRAINT_PREFIX = 'CUST-'

# custom args ----------------------------------------------------------------
'''
    Used as an argument holder for adding constraints.
'''
class ArgHolder(object):
    def __init__(self):
         self.id = 0
         
    def add_arg(self, varName, varValue):
        setattr(self, varName, varValue)
# ----------------------------------------------------------------------------

# write file stuff -----------------------------------------------------------
def write_generated_rig_constraint_link_file(armature):
    wDir = make_directory_string(armature)
    f = open(wDir, "w")
    
    # START WRITING TO FILE
    f.write(f"# ARMATURE \"{armature.name}\" GENERATED RIG CONSTRAINT LINK FILE #\n")
    f.write(f"\n") #write new line for readability.
    for bone in armature.bones:
        # write constraints to files for non MCH/DEF/ORG bones.
        if not 'MCH' in bone.name and not 'DEF' in bone.name and not 'ORG' in bone.name:
            # write constraint data
            write_constraint_info(bone.name, f)
            # write driver data of constraint data
            write_driver_info(armature.name, bone.name, f)
            
    # close the file:
    f.close()
    return 0
# ---------------------------------------------------------------------------

def extract_name_from_pointer_string(pointer_string):
    split = pointer_string.split('\"')
    found_name = ''
    for item in split:
        print(item)
        if '<' not in item and '>' not in item:
            found_name = item
            return found_name
    return ''

def add_driver( target_id:'',
                driver_data_path='',
                driver_bone_name='',
                driver_constraint_name='',
                driver_property_name='',
                expression='',
                is_simple_expression=True,
                is_valid=True,
                driver_type='',
                use_self='',
                var_list=''):
    '''
        adds a driver based on the arguments. var_list should be a list and targets should be a list of var_list.
    '''
                    
    # add the driver.
    print('target_id: ' + str(target_id))
    object_name = extract_name_from_pointer_string(str(target_id))
    armature = bpy.context.scene.objects[object_name]
    #armature.pose.bones[bone.name].constraints[constraintName]
    d = armature.pose.bones[driver_bone_name].constraints[driver_constraint_name].driver_add(driver_property_name, -1)
    d.driver.expression           = expression
    #d.driver.is_simple_expression = str_to_bool(is_simple_expression)
    d.driver.is_valid             = str_to_bool(is_valid)
    d.driver.type                 = driver_type
    d.driver.use_self = str_to_bool(use_self)
    # add the variables:
    if var_list is not None:
        for var in var_list:
            v = d.driver.variables.new()
            v.name                       = var['variable_name']
            v.type                       = var['variable_type']
            print('v.name: '+ var['variable_name'])            
            t = 0
            for target in var['targets']:
                print('variable: ' + str(v.name) + ' | target #' + str(t) + ': \n' + str(target))
                print('TARGETID: '+ target['id'])
                
                '''
                split = target['id'].split('\"')
                found_name = ''
                for item in split:
                    print(item)
                    if '<' not in item and '>' not in item:
                        found_name = item
                '''
                found_name = extract_name_from_pointer_string(target['id'])
                print('found name: ' + found_name)
                v.targets[t].id               = bpy.data.objects[found_name]
                v.targets[t].bone_target      = target['bone_target']
                v.targets[t].context_property = target['context_property']
                v.targets[t].data_path       = target['data_path']
                #v.targets[0].id_type        = id_type
                v.targets[t].rotation_mode   = target['rotation_mode']
                v.targets[t].transform_space = target['transform_space']
                v.targets[t].transform_type  = target['transform_type']
                t += 1
    return
    

# read file stuff -----------------------------------------------------------
READ_STATE_IDLE = 0; # reading useless lines.
READ_STATE_COLLECTING = 1; # gathering parameters
READ_STATE_FINALIZE = 2; # add the constraint

READ_STATE_COLLECTING_CONSTRAINT = 3; # gathering parameters
READ_STATE_COLLECTING_DRIVER = 4; # gathering parameters
READ_STATE_COLLECTING_DRIVER_VARIABLE = 5; # gathering parameters'
READ_STATE_COLLECTING_DRIVER_VARIABLE_TARGET = 6; # gathering parameters
READ_STATE_FINALIZE_CONSTRAINT = 7; # add the constraint
READ_STATE_FINALIZE_DRIVER = 8; # add the constraint
def read_generated_rig_constraint_link_file(armature):    
    
    # open the file:
    wDir = make_directory_string(armature)
    f = open(wDir, "r")
    
    # start reading:
    readState = 0; # what the reader is doing.
    # define constraints arguments
    constraintsArgs = {}
    # define driver args
    driverArgs = {}
    driverArgs['target_id'] = armature
    driverArgs['var_list'] = [{}]
    driverVariable = 0;
    driverVariableTarget = 0;
    for line in f:
        # if idle, read until hitting something important.
        cLine = line
        cLine = cLine.replace("\n", "")
        
        if '@BEGIN' in cLine:
            if 'CONSTRAINT' in cLine:
                readState = READ_STATE_COLLECTING_CONSTRAINT
                print('>Reading constraint:')
            if 'DRIVE' in cLine:
                if 'VARIABLE' in cLine:
                    if 'TARGET' in cLine:
                        if driverVariableTarget == 0:
                            driverArgs['var_list'][driverVariable]['targets'] = [{}]
                        readState = READ_STATE_COLLECTING_DRIVER_VARIABLE_TARGET
                    else:
                        readState = READ_STATE_COLLECTING_DRIVER_VARIABLE                        
                else:
                    readState = READ_STATE_COLLECTING_DRIVER                            
                

        #print(cLine)
        if '@END' in cLine:
            if 'CONSTRAINT' in cLine:
                readState = READ_STATE_FINALIZE_CONSTRAINT
                print('>End constraint:')
            if 'DRIVE' in cLine:
                if 'VARIABLE' in cLine:
                    if 'TARGET' in cLine:
                        driverVariableTarget += 1
                        readState = READ_STATE_IDLE
                    else:
                        driverVariable += 1
                        driverVariableTarget = 0
                        readState = READ_STATE_IDLE                    
                else:
                    readState = READ_STATE_FINALIZE_DRIVER
        
        
        if readState == READ_STATE_IDLE:
            # get current line.
            
            # if the line is a comment, print it.
            if len(cLine) > 0 and cLine[0] == "#":
                print(cLine) #comment line
                
        # if collecting, add to the constraints argument.
        if readState == READ_STATE_COLLECTING_CONSTRAINT:
            if '@BEGIN' in cLine:
                print(" ")
            elif '@END' in cLine:
                print(" ")
            else: 
                # split the line based on the "$:" delimiter
                cLineSplit = cLine.split(DELIMITER)
                key = cLineSplit[0]
                value = 0
                if len(cLineSplit) > 1:
                    # only name is found.  
                    value = cLineSplit[1]
                if key == 'type':
                    key = 'constraint_type'
                #print(f'{key} : {value}')
                constraintsArgs[key] = value
                #cLine = f.readline()
                
        if readState == READ_STATE_COLLECTING_DRIVER:
            print('Collecting driver: ' + cLine)
            if '@BEGIN' in cLine or '@END' in cLine:
                print("")
            elif cLine[0] == '#': 
                print('')
            else: 
                # split the line based on the "$:" delimiter
                cLineSplit = cLine.split(DELIMITER)
                key = cLineSplit[0]
                value = 0
                if len(cLineSplit) > 1:
                    # only name is found.  
                    value = cLineSplit[1]
                if key == 'type':
                    key = 'target_id'
                print(f'{key} : {value}')
                driverArgs[key] = value
                #cLine = f.readline()
                
        if readState == READ_STATE_COLLECTING_DRIVER_VARIABLE:
            print('Collecting driver variable: ' + str(driverVariable))
            if '@BEGIN' in cLine or '@END' in cLine:
                print("")
            elif cLine[0] == '#': 
                print('')
            else:
                # split the line based on the "$:" delimiter
                cLineSplit = cLine.split(DELIMITER)
                key = cLineSplit[0]
                value = 0
                if len(cLineSplit) > 1:
                    # only name is found.  
                    value = cLineSplit[1]
                if key == 'type':
                    key = 'target_id'
                print(f'FOUND THIS: {key} : {value}')
                if driverVariable > len(driverArgs['var_list'])-1:
                    driverArgs['var_list'].append({})
                print('len var_list: '+str(len(driverArgs['var_list'])))
                driverArgs['var_list'][driverVariable][key] = value
                #driverArgs['var_list'][driverVariable] = {key:value}
                #cLine = f.readline()
            
            
        if readState == READ_STATE_COLLECTING_DRIVER_VARIABLE_TARGET:
            print(f'>collecting driver variable {driverVariable} variable target {driverVariableTarget}---')
            if '@BEGIN' in cLine or '@END' in cLine:
                print('')
            elif cLine[0] == '#': 
                print('')
            else:
                # split the line based on the "$:" delimiter
                cLineSplit = cLine.split(DELIMITER)
                key = cLineSplit[0]
                value = 0
                if len(cLineSplit) > 1:
                    # only name is found.  
                    value = cLineSplit[1]
                # maybe remove this????    
                #if key == 'type':
                    #key = 'target_id'
                    
                if driverVariableTarget > len(driverArgs['var_list'][driverVariable]['targets'])-1:
                    driverArgs['var_list'][driverVariable]['targets'].append({})
                    print('added 1, len is now: ' + str(len(driverArgs['var_list'][driverVariable]['targets'])))
                print(f'  >target key/value: {key} : {value}')
                #print(f'driverVariableTarget: {driverVariableTarget}')
                driverArgs['var_list'][driverVariable]['targets'][driverVariableTarget][key] = value
                print('  >this was just added:\n'+str(driverArgs['var_list'][driverVariable]['targets'][driverVariableTarget]))
                #print('targets HERE LOOK AT THIS:' + str(driverArgs['var_list'][driverVariable]['targets'][driverVariableTarget]))
                #cLine = f.readline()
            
                
        if readState == READ_STATE_FINALIZE_CONSTRAINT:
            #print(constraintsArgs)
            # add constraint.
            
            add_constraint_general(**constraintsArgs)
            
            # clear args
            constraintsArgs = {}
            # set reading to idle.
            readState = READ_STATE_IDLE
            #cLine = f.readline()
            
        if readState == READ_STATE_FINALIZE_DRIVER:
            # @todo make the driver with collected data.
            
            #print('driverArgs:\n'+str(driverArgs))
            #print('driverArgs[var_list]:\n'+str(driverArgs['var_list']))
            print('annoyingly long list stuff:')
            #print(driverArgs['var_list'][2]['variable_name'])
            #print(driverArgs['var_list'][2]['targets'])
            #print('driverArgs[var_list][1][targets]:\n'+str(driverArgs['var_list'][1]['targets']))
            print('')
            
            add_driver(**driverArgs)
            # reset everything
            driverArgs = {}
            driverArgs['target_id'] = armature
            driverArgs['var_list'] = [{}]
            driverVariable = 0
            driverVariableTarget = 0
            readState = READ_STATE_IDLE
            
    return 0  

        
            
            
# --------------------------------------------------------------------------

# EXTRACT THE NAME FROM A DATA PATH ----------------------------------------
def extract_name_from_data_path(base_string, sub_string):
    # try to find the string:
    try:
        sub_start = base_string.index(sub_string)
    except:
        return ''
    #
    base_string_len = len(base_string)
    # remove the beginning of the string.
    string_begin = base_string[:-(base_string_len - sub_start)]
    name = base_string.replace(string_begin, '')
    
    
    # find bracket position
    bracket_start = name.index('[')
    bracket_end   = name.index(']')
    # remove what's at the end of the bracket.
    name = name[:-(len(name)-bracket_end-1)]
    # remove the sub string.
    name = name.replace(sub_string, '')
    # remove brackets
    name = name[1: ]
    name = name[ :-1]
    # remove quotes
    name = name[1: ]
    name = name[ :-1]
    
    print('final name: '+name)
    return str(name)
# --------------------------------------------------------------------------


# clear constraints --------------------------------------------------------
def clear_constraints(boneName):
    # clears existing constraints on boneName.
    removed = 0
    # Get the active object in the scene
    obj = bpy.context.active_object
    
    # Check if the active object is an armature
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        # Check if the armature has a bone named boneName
        if boneName in armature.bones:
            # Get the bone named boneName
            bone = obj.pose.bones[boneName]

            # Clear all constraints on the bone
            for constraint in bone.constraints:
                bone.constraints.remove(constraint)
                removed += 1

            print("Constraints cleared on testbone.")
        else:
            print("No bone named 'testbone' found in the armature.")
    else:
        print("No active armature found in the scene.")
    return removed
# -------------------------------------------------------------------------

def str_to_bool(string):
    if string == 'True':
        return True
    if string == 'False':
        return False


        
# get constraint info ----------------------------------------------------
def get_constraint_info(boneName):
    # Get the active object in the scene
    obj = bpy.context.active_object
    # Check if the active object is an armature
    if obj and obj.type == 'ARMATURE':
        armature = obj.data

        # Check if the armature has a bone named boneName
        if boneName in armature.bones:
            # Get the bone named boneName
            bone = obj.pose.bones[boneName]

            # Clear all constraints on the bone
            for constraint in bone.constraints:
                # get the type:
                cType = constraint.type
                # found action constraint: 
                if (cType == 'ACTION'):
                    print(f"# BEGIN ACTION CONSTRAINT--------------------")
                    print(f"type:{constraint.type}")
                    print(f"action:{constraint.action}")
                    print(f"eval_time:{constraint.eval_time}")
                    print(f"frame_end:{constraint.frame_end}")
                    print(f"frame_start:{constraint.frame_start}")
                    print(f"max:{constraint.max}")
                    print(f"min:{constraint.min}")
                    print(f"mix_mode:{constraint.mix_mode}")
                    print(f"subtarget:{constraint.subtarget}")
                    print(f"target:{constraint.target}")
                    print(f"transform_channel:{constraint.transform_channel}")
                    print(f"use_bone_object_action:{constraint.use_bone_object_action}")
                    print(f"use_eval_time:{constraint.use_eval_time}")
                    print(f"# END ACTION CONSTRAINT ---------------------")
                
        else:
            print(f"No bone named 'boneName' found in the armature.")
    else:
        print("No active armature found in the scene.")
# --------------------------------------------------------------------
        

def get_driver_info(armature_name, bone_name):
    armature = bpy.context.scene.objects[armature_name]
    if armature.animation_data is None:            
        return
    
    bone = armature.pose.bones[bone_name]
    for drivers in armature.animation_data.drivers:
        if bone_name in drivers.data_path:
            driver = drivers.driver
            # this is where the datapath lives
            print('\n')
            print('Found drive----------------------------------')
            print('  DATAPATH: '+drivers.data_path)
            print('  variables:')
            for variable in driver.variables:
                print('    is_name_valid: '+str(variable.is_name_valid))
                print('    name: '+str(variable.name))
                print('    type: '+str(variable.type))
                #print('    targets:')
                target_count = 0
                for target in variable.targets:
                    print('      target '+str(target_count)+':')
                    print('        target.bone_target: '+str(target.bone_target))
                    print('        target.context_property: '+str(target.context_property))
                    print('        target.data_path: '+str(target.data_path))
                    print('        target.id: '+str(target.id))
                    print('        target.id_type: '+str(target.id_type))
                    print('        target.rotation_mode: '+str(target.rotation_mode))
                    print('        target.transform_space: '+str(target.transform_space))
                    print('        target.transform_space: '+str(target.transform_type))
                    target_count += 1
            print('\n')


def write_driver_info(armature_name, bone_name, f):
    
    armature = bpy.context.scene.objects[armature_name]
    if armature.animation_data is None:            
        return
    
    bone = armature.pose.bones[bone_name]
    for drivers in armature.animation_data.drivers:
        if CUSTOM_CONSTRAINT_PREFIX in drivers.data_path and bone_name in drivers.data_path:
            f.write('@BEGIN DRIVER\n')
            driver = drivers.driver
            # this is where the datapath lives
            print('\n')
            print('Found drive----------------------------------')
            print('  DATAPATH: '+drivers.data_path)
            split = drivers.data_path.split('.')
            found_bone_name       = ''
            found_constraint_name = ''
            found_property_name   = ''
            # process the data path to get the information we want.
            found_bone_name = extract_name_from_data_path(drivers.data_path, 'bones')
            found_constraint_name = extract_name_from_data_path(drivers.data_path, 'constraints')
            
            # get the last thing in the data path by '.' delimiter. should always be a property.
            for i in range(len(split)):
                item = split[i]
                if i == len(split)-1:
                    found_property_name = item
                    print('  found_property_name: ' + found_property_name)

            f.write(format_driver_data(drivers.data_path,       'driver_data_path'))
            f.write(format_driver_data(found_bone_name,       'driver_bone_name')) 
            f.write(format_driver_data(found_constraint_name,       'driver_constraint_name'))
            f.write(format_driver_data(found_property_name,       'driver_property_name'))
            f.write(format_driver_data(driver.expression,       'expression'))
            f.write(format_driver_data(driver.is_simple_expression,       'is_simple_expression'))
            f.write(format_driver_data(driver.is_valid,       'is_valid'))
            f.write(format_driver_data(driver.type,       'type', 'driver_'))
            f.write(format_driver_data(driver.use_self,       'use_self'))
            f.write('#variables for this driver------\n')
            for variable in driver.variables:
                f.write('@BEGIN DRIVER VARIABLE\n')
                #print('    is_name_valid: '+str(variable.is_name_valid))
                f.write(format_driver_data(variable.is_name_valid, 'is_name_valid')) 
                #print('    name: '+str(variable.name))
                f.write(format_driver_data(variable.name, 'name', 'variable_')) 
                #print('    type: '+str(variable.type))
                f.write(format_driver_data(variable.type, 'type', 'variable_')) 
                #print('    targets:')
                target_count = 0
                for target in variable.targets:
                    f.write('@BEGIN DRIVER VARIABLE TARGET\n')
                    print('      target '+str(target_count)+':')
                    #print('        target.bone_target: '+str(target.bone_target))
                    f.write(format_driver_data(target.bone_target, 'bone_target')) 
                    #print('        target.context_property: '+str(target.context_property))
                    f.write(format_driver_data(target.context_property, 'context_property')) 
                    #print('        target.data_path: '+str(target.data_path))
                    f.write(format_driver_data(target.data_path, 'data_path')) 
                    #print('        target.id: '+str(target.id))
                    f.write(format_driver_data(target.id, 'id')) 
                    #print('        target.id_type: '+str(target.id_type))
                    f.write(format_driver_data(target.id_type, 'id_type'))
                    #print('        target.rotation_mode: '+str(target.rotation_mode))
                    f.write(format_driver_data(target.rotation_mode, 'rotation_mode'))
                    #print('        target.transform_space: '+str(target.transform_space))
                    f.write(format_driver_data(target.transform_space, 'transform_space'))
                    #print('        target.transform_space: '+str(target.transform_type))
                    f.write(format_driver_data(target.transform_type, 'transform_type'))
                    target_count += 1
                    f.write('@END DRIVER VARIABLE TARGET\n')
                f.write('@END DRIVER VARIABLE\n')
            f.write('@END DRIVER\n\n')
            print('\n')
            
    
    return


# format driver data for text file ------------------------------------
def format_driver_data(data, variable, prefix=""):
    return f"{prefix}{variable}{DELIMITER}{data}\n"
# --------------------------------------------------------------------

def format_relationship_data(data, variable, prefix=""):
    return f"{prefix}{variable}{DELIMITER}{data}\n"

# format constraint data for text file -------------------------------
def format_constraint_data(data, variable, prefix=""):
    '''
        this one is a bit weird but here's what's going on: first, we 
        see if the constraint has the attribute 'variable' (which is
        a string, the name of the attribute attempted to be read. Then,
        we evaluate a string expression. This will get the value of the
        variable for writing to the file.
        
        Also handles a special case for target to get just the name.
    '''
    if hasattr(data, variable):
        value = eval('data.'+variable)
        if value != None:
            if variable == 'target' or variable == 'pole_target' or variable == 'action' or variable == 'space_object':        
                value = value.name
            return f"{prefix}{variable}{DELIMITER}{value}\n"
        else:
            return ""
    else:
        return ""
# --------------------------------------------------------------------


      
def write_constraint_info(boneName, f):
    # writes the constraint data of boneName to file F.
    # Get the active object in the scene
    obj = bpy.context.active_object
    # Check if the active object is an armature
    print(f">write_constraint_info: called for bone {boneName}.")
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        # Check if the armature has a bone named boneName
        if boneName in armature.bones:
            # Get the bone named boneName
            bone = obj.pose.bones[boneName]
            
            # go through all bone constraints
            for constraint in bone.constraints:
                # get the type:
                if CUSTOM_CONSTRAINT_PREFIX not in constraint.name:
                    print("   >skipping...")
                else:
                    cType = constraint.type
                    f.write('@BEGIN CONSTRAINT\n')
                    f.write(format_constraint_data(bone,       'name', 'bone_'))                
                    f.write(format_constraint_data(constraint, 'name', 'constraint_'))      
                    f.write(format_constraint_data(constraint, 'type'))
                    f.write(format_constraint_data(constraint, 'target'))
                    f.write(format_constraint_data(constraint, 'subtarget'))
                    f.write(format_constraint_data(constraint, 'head_tail'))
                    f.write(format_constraint_data(constraint, 'action'))
                    f.write(format_constraint_data(constraint, 'min'))
                    f.write(format_constraint_data(constraint, 'max'))
                    f.write(format_constraint_data(constraint, 'frame_end'))
                    f.write(format_constraint_data(constraint, 'frame_start'))
                    f.write(format_constraint_data(constraint, 'use_x'))
                    f.write(format_constraint_data(constraint, 'use_y'))
                    f.write(format_constraint_data(constraint, 'use_z'))
                    f.write(format_constraint_data(constraint, 'invert_x'))
                    f.write(format_constraint_data(constraint, 'invert_y'))
                    f.write(format_constraint_data(constraint, 'invert_z'))
                    f.write(format_constraint_data(constraint, 'distance'))
                    f.write(format_constraint_data(constraint, 'limit_mode'))
                    f.write(format_constraint_data(constraint, 'use_transform_limit'))
                    f.write(format_constraint_data(constraint, 'target_space'))
                    f.write(format_constraint_data(constraint, 'owner_space'))
                    f.write(format_constraint_data(constraint, 'euler_order'))
                    f.write(format_constraint_data(constraint, 'power'))
                    f.write(format_constraint_data(constraint, 'use_make_uniform'))
                    f.write(format_constraint_data(constraint, 'use_offset'))
                    f.write(format_constraint_data(constraint, 'use_add'))
                    f.write(format_constraint_data(constraint, 'use_min_x'))
                    f.write(format_constraint_data(constraint, 'use_min_y'))
                    f.write(format_constraint_data(constraint, 'use_min_z'))
                    f.write(format_constraint_data(constraint, 'use_max_x'))
                    f.write(format_constraint_data(constraint, 'use_max_y'))
                    f.write(format_constraint_data(constraint, 'use_max_z'))   
                    f.write(format_constraint_data(constraint, 'min_x'))
                    f.write(format_constraint_data(constraint, 'min_y'))
                    f.write(format_constraint_data(constraint, 'min_z'))
                    f.write(format_constraint_data(constraint, 'max_x'))
                    f.write(format_constraint_data(constraint, 'max_y'))
                    f.write(format_constraint_data(constraint, 'max_z'))
                    f.write(format_constraint_data(constraint, 'mode'))
                    f.write(format_constraint_data(constraint, 'free_axis'))
                    f.write(format_constraint_data(constraint, 'volume'))
                    f.write(format_constraint_data(constraint, 'use_limit_x'))
                    f.write(format_constraint_data(constraint, 'use_limit_y'))
                    f.write(format_constraint_data(constraint, 'use_limit_z'))
                    f.write(format_constraint_data(constraint, 'use_motion_extrapolate'))
                    f.write(format_constraint_data(constraint, 'map_from'))
                    f.write(format_constraint_data(constraint, 'from_rotation_mode'))
                    f.write(format_constraint_data(constraint, 'from_min_x'))
                    f.write(format_constraint_data(constraint, 'from_min_y'))
                    f.write(format_constraint_data(constraint, 'from_min_z'))
                    f.write(format_constraint_data(constraint, 'from_max_x'))
                    f.write(format_constraint_data(constraint, 'from_max_y'))
                    f.write(format_constraint_data(constraint, 'from_max_z'))
                    f.write(format_constraint_data(constraint, 'from_min_x_rot'))
                    f.write(format_constraint_data(constraint, 'from_min_y_rot'))
                    f.write(format_constraint_data(constraint, 'from_min_z_rot'))
                    f.write(format_constraint_data(constraint, 'from_max_x_rot'))
                    f.write(format_constraint_data(constraint, 'from_max_y_rot'))
                    f.write(format_constraint_data(constraint, 'from_max_z_rot'))
                    f.write(format_constraint_data(constraint, 'from_min_x_scale'))
                    f.write(format_constraint_data(constraint, 'from_min_y_scale'))
                    f.write(format_constraint_data(constraint, 'from_min_z_scale'))
                    f.write(format_constraint_data(constraint, 'from_max_x_scale'))
                    f.write(format_constraint_data(constraint, 'from_max_y_scale'))
                    f.write(format_constraint_data(constraint, 'from_max_z_scale'))
                    
                    f.write(format_constraint_data(constraint, 'map_to'))
                    f.write(format_constraint_data(constraint, 'to_euler_order'))
                    f.write(format_constraint_data(constraint, 'map_to_x_from'))
                    f.write(format_constraint_data(constraint, 'map_to_y_from'))
                    f.write(format_constraint_data(constraint, 'map_to_z_from'))
                    
                    f.write(format_constraint_data(constraint, 'to_min_x'))
                    f.write(format_constraint_data(constraint, 'to_min_y'))
                    f.write(format_constraint_data(constraint, 'to_min_z'))
                    f.write(format_constraint_data(constraint, 'to_max_x'))
                    f.write(format_constraint_data(constraint, 'to_max_y'))
                    f.write(format_constraint_data(constraint, 'to_max_z'))
                    f.write(format_constraint_data(constraint, 'to_min_x_rot'))
                    f.write(format_constraint_data(constraint, 'to_min_y_rot'))
                    f.write(format_constraint_data(constraint, 'to_min_z_rot'))
                    f.write(format_constraint_data(constraint, 'to_max_x_rot'))
                    f.write(format_constraint_data(constraint, 'to_max_y_rot'))
                    f.write(format_constraint_data(constraint, 'to_max_z_rot'))
                    f.write(format_constraint_data(constraint, 'to_min_x_scale'))
                    f.write(format_constraint_data(constraint, 'to_min_y_scale'))
                    f.write(format_constraint_data(constraint, 'to_min_z_scale'))
                    f.write(format_constraint_data(constraint, 'to_max_x_scale'))
                    f.write(format_constraint_data(constraint, 'to_max_y_scale'))
                    f.write(format_constraint_data(constraint, 'to_max_z_scale'))
                    

                    f.write(format_constraint_data(constraint, 'main_axis'))
                    f.write(format_constraint_data(constraint, 'use_cyclic'))
                    f.write(format_constraint_data(constraint, 'track_axis'))
                    
                    # ik
                    f.write(format_constraint_data(constraint, 'pole_target'))
                    f.write(format_constraint_data(constraint, 'pole_subtarget'))
                    f.write(format_constraint_data(constraint, 'pole_angle'))
                    f.write(format_constraint_data(constraint, 'iterations'))
                    f.write(format_constraint_data(constraint, 'chain_count'))
                    f.write(format_constraint_data(constraint, 'use_tail'))
                    f.write(format_constraint_data(constraint, 'use_stretch'))
                    f.write(format_constraint_data(constraint, 'use_location'))
                    f.write(format_constraint_data(constraint, 'use_rotation'))
                    f.write(format_constraint_data(constraint, 'weight'))
                    f.write(format_constraint_data(constraint, 'orient_weight'))
                    #spline
                    f.write(format_constraint_data(constraint, 'use_even_divisions'))
                    f.write(format_constraint_data(constraint, 'use_chain_offset'))
                    f.write(format_constraint_data(constraint, 'use_curve_radius'))
                    f.write(format_constraint_data(constraint, 'y_scale_mode'))
                    f.write(format_constraint_data(constraint, 'xz_scale_mode'))
                    f.write(format_constraint_data(constraint, 'use_original_scale'))
                    f.write(format_constraint_data(constraint, 'bulge'))
                    f.write(format_constraint_data(constraint, 'bulge_min'))
                    f.write(format_constraint_data(constraint, 'bulge_max'))
                    f.write(format_constraint_data(constraint, 'bulge_smooth'))
                    f.write(format_constraint_data(constraint, 'use_bulge_max'))
                    f.write(format_constraint_data(constraint, 'use_bulge_min'))
                    f.write(format_constraint_data(constraint, 'use_bulge_max'))
                    
                    f.write(format_constraint_data(constraint, 'lock_axis'))
                    # @TODO and the rest
                    
                    f.write(format_constraint_data(constraint, 'space_object'))
                    f.write(format_constraint_data(constraint, 'space_subtarget'))
                    
                    f.write(format_constraint_data(constraint, 'transform_channel'))
                    f.write(format_constraint_data(constraint, 'mix_mode'))
                    # special for transformation:
                    f.write(format_constraint_data(constraint, 'mix_mode_rot'))
                    f.write(format_constraint_data(constraint, 'mix_mode_scale'))
                    
                    f.write(format_constraint_data(constraint, 'use_eval_time'))
                    f.write(format_constraint_data(constraint, 'eval_time'))
                    f.write(format_constraint_data(constraint, 'transform_channel'))
                    f.write(format_constraint_data(constraint, 'use_bone_object_action'))
                    f.write(format_constraint_data(constraint, 'influence'))
                    
                    # @test track to
                    # @test stretch to
                    # @test spline IK
                    # @test clamp to
                    
                    # @todo armature?
                    # @TODO child of
                    # @TODO floor
                    # @TODO follow path
                    # @TODO pivot
                    
                    
                    # shrink wrap
                    f.write(format_constraint_data(constraint, 'shrinkwrap_type'))
                    f.write(format_constraint_data(constraint, 'project_axis'))
                    f.write(format_constraint_data(constraint, 'project_axis_space'))
                    f.write(format_constraint_data(constraint, 'project_limit'))
                    f.write(format_constraint_data(constraint, 'use_project_opposite'))
                    f.write(format_constraint_data(constraint, 'cull_face'))
                    f.write(format_constraint_data(constraint, 'use_invert_cull'))
                    f.write(format_constraint_data(constraint, 'wrap_mode'))
                    f.write(format_constraint_data(constraint, 'use_track_normal'))
        
                    
                    
                    
  
                    f.write('@END CONSTRAINT\n')    
                    f.write(f"\n") #write new line for readability.
                    
                
        else:
            print(f"write_constraint_info: bone {boneName} not found in armature.")
    else:
        print(">write_constraint_info: armature not selected.")
# --------------------------------------------------------------------


# ----------------------------------------------------------------------
def make_directory_string(armature):
    '''
    makes a directory string based on the armature name, 
    creating folder/files if none exist.
    '''
    
    # make a folder if none exists.
    print(f">make_directory_string for armature \"{armature.name}\"")
    #make a folder -------------------------------------------
    filepath = bpy.data.filepath
    directory = os.path.dirname(filepath)
    # make path string from armature name and suffix.
    newpath = os.path.join( directory , armature.name+'_constraintlink')
    # create a folder if one doens't exist already:
    if not os.path.exists(newpath):
        print(f">created folder for {armature.name}")
        os.makedirs(newpath)
    # use armature name for file name.
    fileName = f"{armature.name}.txt"
    return newpath+"\\"+fileName
# ----------------------------------------------------------------------

         
# add constraints by args ----------------------------------------------------
def add_constraint_general(armature_name='',constraint_name='constraint', bone_name='bone',
                           constraint_type='COPY_LOCATION',
                           target='null', subtarget='null', influence=1.0,
                           target_space='WORLD', owner_space='WORLD',
                           mix_mode='ADD',
                           # copy location/rotation/scale
                           use_offset=False,
                           euler_order='AUTO',
                           use_x=True, use_y=True, use_z=True, 
                           invert_x=False, invert_y=False, invert_z=False,
                           power=1.0,
                           use_make_uniform=False,
                           use_add=False,
                           offset=0.0,
                           # transformation specific
                           map_from='LOCATION',map_to='LOCATION',
                           from_rotation_mode='AUTO',
                           to_euler_order='AUTO',
                           # mode modes
                            mix_mode_rot='ADD',mix_mode_scale='REPLACE',
                           # map channels
                           map_to_x_from='X', map_to_y_from='Y', map_to_z_from='Z',
                           # min/max values per property
                           from_min_x=0,from_min_y=0,from_min_z=0,
                           from_max_x=0,from_max_y=0,from_max_z=0,
                           from_min_x_scale=0,from_min_y_scale=0,from_min_z_scale=0,
                           from_max_x_scale=0,from_max_y_scale=0,from_max_z_scale=0,
                           from_min_x_rot=0,from_min_y_rot=0,from_min_z_rot=0,
                           from_max_x_rot=0,from_max_y_rot=0,from_max_z_rot=0,
                           
                           to_min_x=0,to_min_y=0,to_min_z=0,
                           to_max_x=0,to_max_y=0,to_max_z=0,
                           to_min_x_scale=0,to_min_y_scale=0,to_min_z_scale=0,
                           to_max_x_scale=0,to_max_y_scale=0,to_max_z_scale=0,
                           to_min_x_rot=0,to_min_y_rot=0,to_min_z_rot=0,
                           to_max_x_rot=0,to_max_y_rot=0,to_max_z_rot=0,
                           
                           # action specific
                           action='none',
                           transform_channel='LOCATION_X',
                           use_bone_object_action=False,
                           
                           min=0.0, max=0.0,
                           frame_start=0,frame_end=0,
                           
                           forward_axis='FORWARD_X',
                           up_axis='UP_X',
                           use_fixed_location=False,
                           use_curve_radius=False,
                           use_curve_follow=False,
                           
                           floor_location='FLOOR_X',
                           use_rotation=False,
                           
                           # limits
                           distance=0.0,
                           limit_mode='LIMITDIST_INSIDE',
                           use_transform_limit=False,
                           
                           head_tail=0.0,
                           
                           use_min_x=False,
                           use_min_y=False,
                           use_min_z=False,
                           
                           use_max_x=False,
                           use_max_y=False,
                           use_max_z=False,
                           
                           min_x=0.0,
                           min_y=0.0,
                           min_z=0.0,
                           
                           max_x=0.0,
                           max_y=0.0,
                           max_z=0.0,
                           
                           #child of
                           use_location_x=True,
                           use_location_y=True,
                           use_location_z=True,
                           use_rotation_x=True,
                           use_rotation_y=True,
                           use_rotation_z=True,
                           use_scale_x=True,
                           use_scale_y=True,
                           use_scale_z=True,
                           
                           #track to
                           track_axis='TRACK_X',
                           use_target_z=False,
                           
                           #stretch to @todo add more
                           rest_length=0.0,
                           bulge=1.0,
                           
                           space_subtarget=None,
                           use_eval_time=False,
                           eval_time=0.0,
                           
                           shrinkwrap_type='NEAREST_SURFACE',
                           project_axis='POS_Z',
                           project_axis_space='LOCAL',
                           project_limit=0,
                           use_project_opposite=False,
                           cull_face='OFF',
                           use_invert_cull=False,
                           wrap_mode='ON_SURFACE',
                           use_track_normal=False,

                           
                           use_motion_extrapolate=False):

    
    print(f">add_constraint_general: Trying to add \"{constraint_name}\" to \"{bone_name}\"")
    print(target)
    print(frame_end)
    #obj = bpy.context.active_object
    obj = bpy.context.active_object
    # Check if the active object is an armature
    if obj and obj.type == 'ARMATURE':
        armature = obj.data

        # Check if the armature has a bone named "testbone"
        if bone_name in armature.bones:
            # if the bone was found, set bone to the found bone.
            bone = armature.bones[bone_name]
            # clear constraints to make sure it's clean.
            # clear_constraints(bone.name)
            # create a new constraint
            constraint = obj.pose.bones[bone_name].constraints.new(type=constraint_type)

            # Set the target bone for the constraint (e.g., the root bone in this case)
            #constraint.target = obj
            #constraint.subtarget = subtargetName  # Replace "root" with the actual name of the target bone

            # name -------------------------------
            if hasattr(constraint, 'name'):
                constraint.name = constraint_name
                
            if hasattr(constraint, 'target'):
                constraint.target = bpy.data.objects[target]
                
            if hasattr(constraint, 'subtarget'):
                constraint.subtarget = subtarget
                
            if hasattr(constraint, 'influence'):
                constraint.influence = float(influence)
            
            if hasattr(constraint, 'use_motion_extrapolate'):
                constraint.use_motion_extrapolate = str_to_bool(use_motion_extrapolate)

            if hasattr(constraint, 'map_from'):
                constraint.map_from = map_from
                
            if hasattr(constraint, 'map_to'):
                constraint.map_to = map_to
                
            if hasattr(constraint, 'transform_channel'):
                constraint.transform_channel = transform_channel 
                 
            if hasattr(constraint, 'target_space'):
                constraint.target_space = target_space

            if hasattr(constraint, 'offset'):
                constraint.offset = offset
                
            if hasattr(constraint, 'min'):
                constraint.min = float(min)
                
            if hasattr(constraint, 'max'):
                constraint.max = float(max)
 
            if hasattr(constraint, 'distance'):
                constraint.distance = float(distance)
                
            if hasattr(constraint, 'limit_mode'):
                constraint.limit_mode = limit_mode
                
            if hasattr(constraint, 'use_transform_limit'):
                constraint.use_transform_limit = str_to_bool(use_transform_limit)
                
            if hasattr(constraint, 'mix_mode'):
                constraint.mix_mode = mix_mode
                
            if hasattr(constraint, 'head_tail'):
                constraint.head_tail = float(head_tail)
                
            if hasattr(constraint, 'target_space'):
                constraint.target_space = target_space
                
            if hasattr(constraint, 'owner_space'):
                constraint.owner_space = owner_space
                
            if hasattr(constraint, 'action'):
                constraint.action = bpy.data.actions[action]
                
            if hasattr(constraint, 'use_bone_object_action'):
                constraint.use_bone_object_action = eval(str(use_bone_object_action))
                
            if hasattr(constraint, 'frame_start'):
                constraint.frame_start = int(frame_start)
                
            if hasattr(constraint, 'frame_end'):
                constraint.frame_end = int(frame_end)
                
            if hasattr(constraint, 'forward_axis'):
                constraint.forward_axis = forward_axis
                
            if hasattr(constraint, 'up_axis'):
                constraint.up_axis = up_axis
                
            if hasattr(constraint, 'track_axis'):
                constraint.track_axis = track_axis
                
            if hasattr(constraint, 'use_target_z'):
                constraint.use_target_z = use_target_z
                
            if hasattr(constraint, 'use_fixed_location'):
                constraint.use_fixed_location = use_fixed_location
                
            if hasattr(constraint, 'use_curve_radius'):
                constraint.use_curve_radius = use_curve_radius
                
            if hasattr(constraint, 'use_curve_follow'):
                constraint.use_curve_follow = use_curve_follow
                
            if hasattr(constraint, 'floor_location'):
                constraint.floor_location = floor_location
                
            if hasattr(constraint, 'use_rotation'):
                constraint.use_rotation = use_rotation
                
            if constraint_type == 'LIMITE_LOCATION':
                constraint.use_min_x = use_min_x
                constraint.use_min_y = use_min_y
                constraint.use_min_z = use_min_z
                constraint.use_max_x = use_max_x
                constraint.use_max_y = use_max_y
                constraint.use_max_z = use_max_z
                constraint.min_x = min_x
                constraint.min_y = min_y
                constraint.min_z = min_z
                constraint.max_x = max_x
                constraint.max_y = max_y
                constraint.max_z = max_z
                
            if constraint_type == 'ACTION':
                constraint.mix_mode = mix_mode

            if constraint_type == 'ARMATURE':
                constraint.use_deform_preserve_volume = use_deform_preserve_volume
                constraint.use_bone_envelopes         = use_bone_envelopes
                constraint.use_current_location       = use_current_location

            if constraint_type == 'CHILD_OF':
                constraint.use_location_x = use_location_x
                constraint.use_location_y = use_location_y
                constraint.use_location_z = use_location_z
                constraint.use_rotation_x = use_rotation_x
                constraint.use_rotation_y = use_rotation_y
                constraint.use_rotation_z = use_rotation_z
                constraint.use_scale_x    = use_scale_x
                constraint.use_scale_y    = use_scale_y
                constraint.use_scale_y    = use_scale_y

            if constraint_type == 'TRANSFORM':
                constraint.from_min_x       = float(from_min_x)
                constraint.from_min_y       = float(from_min_y)
                constraint.from_min_z       = float(from_min_z)
                constraint.from_max_x       = float(from_max_x)
                constraint.from_max_y       = float(from_max_y)
                constraint.from_max_z       = float(from_max_z)
                constraint.from_min_x_scale = float(from_min_x_scale)
                constraint.from_min_y_scale = float(from_min_y_scale)
                constraint.from_min_z_scale = float(from_min_z_scale)
                constraint.from_max_x_scale = float(from_max_x_scale)
                constraint.from_max_y_scale = float(from_max_y_scale)
                constraint.from_max_z_scale = float(from_max_z_scale)
                constraint.from_min_x_rot   = float(from_min_x_rot)
                constraint.from_min_y_rot   = float(from_min_y_rot)
                constraint.from_min_z_rot   = float(from_min_z_rot)
                constraint.from_max_x_rot   = float(from_max_x_rot)
                constraint.from_max_y_rot   = float(from_max_y_rot)
                constraint.from_max_z_rot   = float(from_max_z_rot)
                constraint.map_to         = map_to
                constraint.to_euler_order = to_euler_order
                constraint.map_to_x_from  = map_to_x_from
                constraint.map_to_y_from  = map_to_y_from
                constraint.map_to_z_from  = map_to_z_from
                constraint.to_min_x       = float(to_min_x)
                constraint.to_min_y       = float(to_min_y)
                constraint.to_min_z       = float(to_min_z)
                constraint.to_max_x       = float(to_max_x)
                constraint.to_max_y       = float(to_max_y)
                constraint.to_max_z       = float(to_max_z)
                constraint.to_min_x_rot   = float(to_min_x_rot)
                constraint.to_min_y_rot   = float(to_min_y_rot)
                constraint.to_min_z_rot   = float(to_min_z_rot)
                constraint.to_max_x_rot   = float(to_max_x_rot)
                constraint.to_max_y_rot   = float(to_max_y_rot)
                constraint.to_max_z_rot   = float(to_max_z_rot)
                constraint.to_min_x_scale = float(to_min_x_scale)
                constraint.to_min_y_scale = float(to_min_y_scale)
                constraint.to_max_z_scale = float(to_max_z_scale)
                constraint.to_min_z_scale = float(to_min_z_scale)
                constraint.to_max_x_scale = float(to_max_x_scale)
                constraint.to_max_y_scale = float(to_max_y_scale)
                # extra mix modes:
                constraint.mix_mode_scale = mix_mode_scale
                constraint.mix_mode_rot   = mix_mode_rot
                
                
                
            if constraint_type == 'SHRINKWRAP':
                constraint.shrinkwrap_type      = shrinkwrap_type
                constraint.project_axis         = project_axis
                constraint.project_axis_space   = project_axis_space
                constraint.project_limit        = float(project_limit)
                constraint.use_project_opposite = str_to_bool(use_project_opposite)
                #print('use_project_opposite BOOL IS THIS: '+str(str_to_bool(use_project_opposite)))
                constraint.cull_face            = cull_face
                constraint.use_invert_cull      = str_to_bool(use_invert_cull)
                #print('use_invert_cull BOOL IS THIS: '+str(str_to_bool(use_invert_cull)))
                constraint.wrap_mode            = wrap_mode
                constraint.use_track_normal     = str_to_bool(use_track_normal)
                #print('use_track_normal BOOL IS THIS: '+str(str_to_bool(use_track_normal)))


            #print(f"   >Action constraint \"{constraint_name}\" added to \"{bone_name}\"")
        else:
            print(f"   >Bone \"{bone_name}\" not found.")
    else:
        print(">!error: No active armature found in the scene.")
        
# ----------------------------------------------------------------------------

        
def save_custom_constraints():
    obj = bpy.context.active_object
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        return write_generated_rig_constraint_link_file(armature)
    
def load_custom_constraints():
    obj = bpy.context.active_object
    if obj and obj.type == 'ARMATURE':
        armature = obj.data
        return read_generated_rig_constraint_link_file(armature)
        #print(">load_custom_constraints: error, obj is not armature.")
        
def clear_custom_constraints():
    print(">clear_custom_constraints: todo make it work")
    return 0

def clear_custom_constraints_all():
    print(">clear_custom_constraints_all: todo make it work")
    return 0



#save_custom_constraints()
#load_custom_constraints()